# Vet mooi notebook van Bas

Laten we beginnen met de imports


```python
import re 
import numpy as np
from functools import reduce
from math import factorial
```

## Puzzel 1

### Deel 1


```python
f = open('data/puzzle_1.txt', 'r')
total = 0
for line in f:
    digit_1 = re.search('(\d)', line).group()
    digit_2 = re.search('(?:\d)(?!.*\d)', line).group()
    total += int(digit_1+digit_2)
total
```




    55834



### Deel 2


```python
l = ['one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine']
digits = '|'+'|'.join(l)
f = open('data/puzzle_1.txt', 'r')
total = 0
for line in f:
    string_digits = re.findall('(?=(\d'+digits+'))', line)
    string_digits = [digit if (digit not in l) else str(l.index(digit)+1) for digit in string_digits]
    total += int(string_digits[0] + string_digits[-1])
total
```




    53221



## Puzzel 2


```python
data = open('data/puzzle_2.txt', 'r').readlines()
```

### Deel 1


```python
color_dict = {
    'red': 12,
    'green': 13,
    'blue': 14
}
total = 0
for line in data:
    possible = True
    for amount, color in re.findall('(\d+)\W*(red|green|blue)', line):
        if (color_dict[color] < int(amount)):
            possible = False
    if possible:
        total += int(re.findall('(\d+)', line)[0])
total
```




    3035



### Deel 2


```python
total = 0
for line in data:
    color_dict = {'red': [], 'green': [], 'blue': []}
    
    for pair in re.findall('(\d+)\W*(red|green|blue)', line):
        color_dict[pair[1]].append(int(pair[0]))
    total += max(color_dict['red']) * max(color_dict['green']) * max(color_dict['blue'])
total
```




    66027



## Puzzel 3


```python
data = open('data/puzzle_3.txt', 'r').readlines()
```


```python
data_list = [re.sub('\n', '', line) for line in data]
data_list = [re.sub('[^\d\.]', 'X', line) for line in data_list]
total = 0
for line_number, line in enumerate(data_list):
    matches = re.findall('\d+', line)
    for number in matches:
        match = re.search(number, line)
        surrounding_string = ""
        start, end = match.span()
        if start > 0:
            start -= 1
        if end <= len(line):
            end += 1
        if line_number != 0:
            surrounding_string += data_list[line_number-1][start:end]
        surrounding_string += line[start:end]
        if line_number != len(data_list)-1:
            surrounding_string += data_list[line_number+1][start:end]
        if 'X' in surrounding_string:
            total += int(match.group())
        line = re.sub(match.group(), len(match.group())*'.', line, 1)
        match = re.search('\d+', line)        
total
```




    517021




```python
data_list = [re.sub('\n', '', line) for line in data]
asterisks = []
numbers = []
for line_number, line in enumerate(data_list):
    match = re.search('(\*)|(\d+)', line)
    while match is not None:
        x, y = match.span()
        if match.group() == '*':
            asterisks.append({'x_pos': x, 'line_number': line_number})
        else:
            numbers.append({'x_start':x, 'x_end': y, 'line_number': line_number, 'number': int(match.group())})
        line = re.sub('(\*)|(\d+)', len(match.group())*'.', line, 1)
        match = re.search('(\*)|(\d+)', line)
        
for asterisk in asterisks:
    asterisk_numbers = []
    for number in numbers:
        if number['line_number'] == asterisk['line_number']:
            if number['x_end'] == asterisk['x_pos']:
                asterisk_numbers.append(number['number'])
                continue
            if number['x_start']-1 == asterisk['x_pos']:
                asterisk_numbers.append(number['number'])
                continue
        
        if (number['line_number']+1 == asterisk['line_number']) or (number['line_number']-1 == asterisk['line_number']):
            if asterisk['x_pos'] in [num for num in range(number['x_start']-1, number['x_end']+1)]:
                asterisk_numbers.append(number['number'])

    asterisk['numbers'] = asterisk_numbers
total = 0
for asterisk in asterisks:
    if len(asterisk['numbers']) == 2:
           total+= asterisk['numbers'][0] * asterisk['numbers'][1]
total
```




    81296995



## Puzzel 4

### Deel 1


```python
data = open('data/puzzle_4.txt', 'r').readlines()
```


```python
# initiating output variable
total = 0
for line in data:
    # Cleaning identifier as it is not necessary
    line_number_part = line.split(':')[1]

    # Removing the \n 
    line_number_part = re.sub('\n', '',line_number_part)

    # Creating a set with winning numbers and with owned numbers
    winning_numbers, owned_numbers = line_number_part.split('|')

    # Getting the seperate numbers
    winning_numbers = re.findall('(\d+)', winning_numbers)
    owned_numbers = re.findall('(\d+)', owned_numbers)

    # Converting to a set to prepare for intersect
    winning_set = set(winning_numbers)
    owned_set = set(owned_numbers)

    # Only numbers that are both owned and winning will be left
    winning_numbers_owned = winning_set.intersection(owned_set)

    # Get the number of matches
    matched_number_count = len(winning_numbers_owned)

    # If there are no matches, we add nothing to total, so we check for zero matches
    if matched_number_count > 0:
        # We then add to the total 2 to the power of the total number of matches minus one, as we start at 1 instead of 2 and 2^0 is 1 
        total += 2**(matched_number_count-1)
print(total)
```

    21568
    

### Deel 2


```python
# initiating output variable
total = 0
winning_numbers_on_card = []
card_numbers = []
copies_of_card = []
for line in data:
    # Cleaning identifier
    card_identifier_part, line_number_part = line.split(':')
    identifier = int(re.search('\d+', card_identifier_part).group())

    # adding to the list
    card_numbers.append(identifier)

    # Also adding a 1 to the owned cards list
    copies_of_card.append(1)

    # Removing the \n 
    line_number_part = re.sub('\n', '',line_number_part)

    # Creating a set with winning numbers and with owned numbers
    winning_numbers, owned_numbers = line_number_part.split('|')

    # Getting the seperate numbers
    winning_numbers = re.findall('(\d+)', winning_numbers)
    owned_numbers = re.findall('(\d+)', owned_numbers)

    # Converting to a set to prepare for intersect
    winning_set = set(winning_numbers)
    owned_set = set(owned_numbers)

    # Only numbers that are both owned and winning will be left
    winning_numbers_owned = winning_set.intersection(owned_set)

    # Get the number of matches
    matched_number_count = len(winning_numbers_owned)

    # Add to card info list
    winning_numbers_on_card.append(matched_number_count)


# Just simulating the rounds, if a card has winining numbers, loop over a range and add that loop variable to the card number
# if the card number exists, we simply add the number of copies of the current card to that card
# etc. 
for i, card_id in enumerate(card_numbers):
    winning_numbers = winning_numbers_on_card[i]
    for number in range(1, winning_numbers+1):
        if (card_id+number) in card_numbers:
            id_to_add_to = card_numbers.index(card_id+number)
            copies_of_card[id_to_add_to] += copies_of_card[i]

# just sum the total cards at the end
print(sum(copies_of_card))
        
    
    
```

    11827296
    

# AANSCHOUW!!!!!
Het wonder, het fantastischste ding ooit, oneliners


```python
reduce(lambda total, multipliers: (total + 2**(multipliers-1) if (multipliers > 0) else total) ,map(lambda numbers: len(numbers)-len(set(numbers)), [re.findall('(?:(\d+)\s|\n)', line) for line in open('data/puzzle_4.txt')]), 0)
```




    21568




```python
sum([y for (x,y) in reduce(lambda total, cards: total + [(cards[0], 1)] + [(card, 1+sum([total_card[1] for total_card in total if total_card[0] == cards[0]])) for card in cards[1]], enumerate([j+1+i for j in range(len(re.findall(r'(?:\b(\d+)\s)(?=.*\s\1\b)', line)))] for i, line in enumerate(open('data/puzzle_4.txt'))), [])])
```




    11827296



## Puzzel 5

### Deel 1


```python
data = open('data/puzzle_5.txt','r').readlines()
seeds = [int(seed) for seed in re.findall(r'\d+', data[0])]

seed_maps = []
map_names = []
mapping = []
for line in data[1:]:
    if 'map' in line:
        mapping = []
        map_names.append(line)
    if line == '\n':
        seed_maps.append(mapping)
    ints = [int(value) for value in re.findall(r'\b(\d+)', line)]
    if len(ints) > 0:
        mapping.append(ints)
seed_maps.append(mapping)

for mapping in seed_maps:
    if len(mapping) < 1:
        continue
    new_seeds = []
    for map_row in mapping:
        for seed in seeds:
            if (map_row[1]+map_row[2]) > seed >= map_row[1]:
                new_seeds.append(seed+map_row[0]-map_row[1])
    seeds = new_seeds
print(seeds)
min(seeds)
```

    [3871578677, 1724133724, 199602917, 2982314302, 595680226, 692431340, 2899305373, 2926286942, 4220409748, 2324727144, 2504054106, 2942258417, 1481150454, 1479468889, 2022824054, 4001340211, 3089202785]
    




    199602917



## Deel 2


```python
data = open('data/puzzle_5.txt','r').readlines()
seeds = [{'start': int(x), 'end': int(x) + int(y)} for (x,y) in re.findall(r'(?:(\d+)\s(\d+))', data[0])]
seed_maps = []
map_names = []
mapping = []
for line in data[1:]:
    if 'map' in line:
        mapping = []
        map_names.append(line)
    if line == '\n':
        if len(mapping) > 0:
            seed_maps.append(mapping)
    ints = [int(value) for value in re.findall(r'\b(\d+)', line)]
    if len(ints) > 0:
        mapping.append({'start': ints[1], 'end': ints[1]+ints[2], 'change': ints[0] - ints[1]})
seed_maps.append(mapping)
for seed_map in seed_maps:
    new_seeds = []
    for seed in seeds:
        bounds = [(seed['start'], 0), (seed['end'], 0)]
        for row in seed_map:
            if (row['start'] >= seed['end']) or (row['end'] <= seed['start']):
                continue
            if row['start'] <= seed['start']:
                bounds.append((seed['start'], row['change']))
            else:
                bounds.append((row['start'], row['change']))
            if row['end'] < seed['end']:
                bounds.append((row['end'], 0))
        bounds.sort(key=lambda x: x[0])
        for i in range(len(bounds)-1):
            lower_bound = bounds[i]
            upper_bound = bounds[i+1]
            if lower_bound[0] != lower_bound[1]:
                new_seeds.append({'start': lower_bound[0]+lower_bound[1], 'end': upper_bound[0]+lower_bound[1]})
    seeds = new_seeds
min([seed['start'] for seed in seeds])
```




    2254686



## Puzzel 6

## Deel 1


```python
data = open('data/puzzle_6.txt', 'r').readlines()
times = [int(time) for time in re.findall(r'(\d+)', data[0])]
distances = [int(distance) for distance in re.findall(r'(\d+)', data[1])]
```

    [358, 1054, 1807, 1080] [46, 68, 98, 66]
    


```python
total_wins = []
for time, distance in zip(times, distances):
    wins = 0
    for time_pressed in range(0, time+1):
        distance_travelled = time_pressed * (time-time_pressed)
        if distance_travelled > distance:
            wins += 1
    total_wins.append(wins)
score = 1
for win in total_wins:
    score = score*win
score
    
```




    138915



## Deel 2


```python
time = [time for time in re.findall(r'(\d+)', data[0])]
time = int(''.join(time))
distance = [distance for distance in re.findall(r'(\d+)', data[1])]
distance = int(''.join(distance))


discriminant = (time**2) - (4 * distance)
x0 = ((-time) + np.sqrt(discriminant))/-2
x1 = ((-time) - np.sqrt(discriminant))/-2
print(x0, x1)
round(x1) - round(x0)-1
```

    9674509.498754364 37015356.50124563
    




    27340847




```python
[round(number[0] - number[1]) for number in [[(-1 * numbers[1] + np.sqrt(numbers[0]))/2, ((-1 * numbers[1]) - np.sqrt(numbers[0]))/2] for numbers in [[((numbers[0]**2) - (4 * numbers[1]))]+numbers for numbers in [[int(''.join(re.findall('(\d+)', line))) for line in open('data/puzzle_6.txt')]]]]][0]
```




    27340847



## Puzzel 7

## Deel 1


```python
data = re.findall(r'(\w+)\s(\d+)',open('data/puzzle_7.txt', 'r').read(), flags=re.MULTILINE)
values = "AKQJT98765432"
hands = [{'cards': x, 'bid': int(y)} for x,y in data]

fivek = []
fourk = []
fh = []
threek = []
twop = []
onep = []
hc = []
for hand in hands:
    hand['values'] = np.array([hand['cards'].count(letter) for letter in values])
    max_card = np.argmax(hand['values'])

    if max(hand['values']) == 5:
        fivek.append(hand)
    elif max(hand['values']) == 4:
        fourk.append(hand)
    elif max(hand['values']) == 3:
        if np.any(hand['values'] == 2):
            fh.append(hand)
        else:
            threek.append(hand)
    elif max(hand['values']) == 2:
        if sum(hand['values'] > 1) == 2:
            twop.append(hand)
        else:
            onep.append(hand)
    else:
        hc.append(hand)
combos = [fivek, fourk, fh, threek, twop, onep, hc]
for combo in combos:
    combo.sort(key=lambda hand: ''.join([chr(values.index(letter)+96) for letter in hand['cards']]))
combos = [val for sublist in combos for val in sublist] 
combos = combos[::-1]
sum([(i+1)*hand['bid'] for i, hand in enumerate(combos)])
```




    250120186



### Deel 2


```python
data = re.findall(r'(\w+)\s(\d+)',open('data/puzzle_7.txt', 'r').read(), flags=re.MULTILINE)
values = "AKQT98765432J"
hands = [{'cards': x, 'bid': int(y)} for x,y in data]

fivek = []
fourk = []
fh = []
threek = []
twop = []
onep = []
hc = []
for hand in hands:
    hand['values'] = np.array([hand['cards'].count(letter) for letter in values if letter != 'J'])
    max_card = np.argmax(hand['values'])
    hand['values'][max_card] += hand['cards'].count('J')

    if max(hand['values']) == 5:
        fivek.append(hand)
    elif max(hand['values']) == 4:
        fourk.append(hand)
    elif max(hand['values']) == 3:
        if np.any(hand['values'] == 2):
            fh.append(hand)
        else:
            threek.append(hand)
    elif max(hand['values']) == 2:
        if sum(hand['values'] > 1) == 2:
            twop.append(hand)
        else:
            onep.append(hand)
    else:
        hc.append(hand)
combos = [fivek, fourk, fh, threek, twop, onep, hc]
for combo in combos:
    combo.sort(key=lambda hand: ''.join([chr(values.index(letter)+96) for letter in hand['cards']]))
combos = [val for sublist in combos for val in sublist] 
combos = combos[::-1]
sum([(i+1)*hand['bid'] for i, hand in enumerate(combos)])
```




    250665248



## Puzzel 8

### Deel 1


```python
data = open('data/puzzle_8.txt', 'r').read()
directions = re.search(r'(\w+)', data).group()
nodes = {x: {'L': y, 'R': z} for x,y,z in re.findall(r'(\w{3}).*\((\w{3}).*(\w{3})', data, flags=re.MULTILINE)}
steps = 0
current_node = 'AAA'

while current_node != 'ZZZ':
    for direction in directions:
        current_node = nodes[current_node][direction]
        steps += 1
        if current_node == 'ZZZ':
            break
print(steps)
```

    20777
    

### Deel 2


```python
current_nodes = re.findall('(\w{2}A)\s', data, flags=re.MULTILINE)
all_matches = []
for node in current_nodes:
    matches = []
    steps = 0
    while len(matches) < 10:
        for letter in directions:
            node = nodes[node][letter]
            steps += 1
            if node[2] == 'Z':
                matches.append(steps)
    all_matches.append(matches)
lowest = [matches[0] for matches in all_matches]

val = np.gcd.reduce(lowest)
total = 1
for x in [x/val for x in lowest]:
    total *= x
int(total * val)
    
        
       
        
```




    13289612809129



## Puzzel 10!!!

### Deel 1


```python
data = open('data/puzzle_10.txt', 'r').readlines()
data = [re.sub('\n', '', line) for line in data]
start_position = [(i, line.index('S')) for i, line in enumerate(data) if 'S' in line][0]
start_position
```




    (42, 8)




```python
def get_next_direction(current_direction, pipe):
    if pipe in 'FJ':
        current_direction = (-current_direction[1], -current_direction[0])
    if pipe in '7L':
        current_direction = (current_direction[1], current_direction[0])
    return current_direction
```


```python
current_position = start_position
for current_direction in [(1,0),(-1,0),(0,1),(0,-1)]:
    current_position = start_position
    steps = 0
    while data[current_position[0]][current_position[1]] != 'S' or steps == 0:
        current_position = (current_position[0] + current_direction[0], current_position[1] + current_direction[1])
        steps += 1
        current_direction = get_next_direction(current_direction, data[current_position[0]][current_position[1]])
        if data[current_position[0]][current_position[1]] == '.':
            break
    print(steps)
```

    13676
    6
    13676
    60
    


```python
current_position = start_position
loop = [[{'direction': (0,0), 'letter': '.'}] * len(line) for line in data]
current_direction = (1, 0)
steps = 0
while data[current_position[0]][current_position[1]] != 'S' or steps == 0:
    current_position = (current_position[0] + current_direction[0], current_position[1] + current_direction[1])
    current_direction = get_next_direction(current_direction, data[current_position[0]][current_position[1]])
    letter = data[current_position[0]][current_position[1]]
    loop[current_position[0]][current_position[1]] = {'letter': letter}
    steps += 1

loop[42][8] = {'direction': (1, 0), 'letter': 'F'}
grid = []
total = 0
for line in loop:
    row = ""
    in_loop = False
    last = ''
    for item in line:
        if item['letter'] in 'FL':
            last = item['letter']
        elif item['letter'] in '||':
            in_loop = not in_loop
        elif item['letter'] == '7' and last == 'L':
            in_loop = not in_loop
            last = item['letter']
        elif item['letter'] == 'J' and last == 'F':
            in_loop = not in_loop
            last = item['letter']

        if item['letter'] == '.' and in_loop:
            row += 'O'
            total += 1
        elif item['letter'] != '.':
            row += item['letter']
        else:
            row += ' '
    grid.append(row)

print(total)
grid


```

    451
    




    ['                                                                                                                                            ',
     '                                                                                                                                            ',
     '                                                                                                                                            ',
     '                                                    F7                                                                                      ',
     '                                                    ||                                                                                      ',
     '                                                    |L7   F7                                F--7 F7                                         ',
     '                                                    L7L7F7||                                L-7L7||F7                                       ',
     '                             F-7F7                F-7L7||||L7                                 L7||LJL7                                      ',
     '                             L7LJ|  F7            L7| |LJLJFJ                              F-7FJ||F--J                                      ',
     '                            F-JF-J  |L7  F7   F-7F-JL7L-7F-J                 F7            L7LJFJ||F7F7        F7                           ',
     '                            L-7| F-7|FJ  |L7  L7|L--7L7FJL---7F-7          F-JL7F7F7  F--7F7L-7L7|||LJ|   F7  FJL7                          ',
     '                           F--J|FJFJ||  FJFJ F-JL7F7|FJL-7F--J|FJ F7       L--7LJ||L-7|F-J||F7|FJ|||F-J  FJL-7|F-J                          ',
     '                           L--7||FJ ||F7L7|F7L--7||LJL7F-JL-7FJL7FJL--7   F7F7L7FJ|F-J||F-J||||L-J|||F7F7L-7FJ|| F7F-7                      ',
     '                          F7 FJLJ|F7||||FJ|||F7FJ|L--7|L7F--JL7FJ|F-7FJF7FJLJL7|L-JL7 ||L-7|||L-7FJ|||||| FJL-J|FJ|L7|                      ',
     '                          |L7L--7||||LJ|L7LJ|||L7L7F7|L7|L-7F7||FJL7||FJ|L-7F-J|F--7L-JL-7||||F-J|FJLJLJL7L---7LJFJFJL-7                    ',
     '                       F7 |FJF--JLJLJF7| L-7|||FJFJ||L7|L-7LJLJLJF-JLJL7| FJL7 LJF-JF7F-7||LJ|L-7|L7F----JF7F-JF-JFJF7FJ                    ',
     '                       ||FJ| L-7F7F--JLJF7FJ|||L7| || ||F7L-7F--7L-7 F7|L-JF-JF7 L--J|| |||F-JF7|| ||F7F7FJ|L-7|F-JFJLJ                     ',
     '                       |||FJF7 LJ||F--7FJ|L7LJL-JL7|L7|LJ|F7||F7L--JFJ||F-7|F7||F-7F7LJFJLJ|F7|||L-JLJLJ|L7L7 ||L7FJ                        ',
     '                     F7||||FJ|F--J|L7FJL7L7|F-----J|FJL7FJ||||||F7F7L7|LJ |||||||FJ|L7FJF-7||||||F--7F-7|FJFJFJL7||F7      F-7              ',
     '                     |LJ|||L7|L--7| |L-7L7||| F-7F-J|F7|L7|||LJLJLJL7|L7F-J||LJ||L7L7|L7|FJ||||||L-7LJ LJL7|FJF-J|LJL7     L7|              ',
     '                    FJF7LJL7|| F-JL-JF-JFJ||L7|FJL-7|||L7LJLJF------J|FJL-7||F-JL7| |L7LJL7||||||F-J F7 F7|||FJF-JF--J      ||F7            ',
     '                    L-JL7F7LJL7L----7| FJFJL7LJL7F7|LJL7L-7F-JF---7F7|L7F7||||F7 |L7L7L---JLJ|||||F-7|L7|||||| |F-JF7      FJLJ|            ',
     '                     F--J|L-7FJF----JL7L7L7FJF--J||L7F-J FJL-7L7F7||LJFJ|||LJLJL7L7L7L------7LJ||||FJ|FJ|||||L-J|F7||F7F-7FJF--J            ',
     '             F7      L--7|F-JL7L----7FJ |FJL7L7F7|| ||F7FJF--JFJ|LJL-7L7||L--7F-JFJFJF-----7L-7LJ||L-JL7|||||F7FJ|||||||FJL7L7              ',
     '             ||       F7LJL--7| F7F7||F-J|F7L7|||||FJ||||FJ F7L7|F7F-JFJ|L7F7|L-7L7L7L--7F7L--JF7LJF--7|||||||LJFJLJLJLJL7FJFJ              ',
     '           F-J|   F7F-JL-7F--JL7|LJ||LJF-J|| |LJLJ|L7|||||F7|L7|LJ|L-7L7L7||LJF-J |FJF-7LJL----J|F-JF7LJ|||||L-7|F7F-----J|FJ               ',
     '           L-7|F7 ||L--7FJL---7|L-7|L-7|F-JL7L---7L7|LJLJLJ|L7||F-JF7L7L-J|L-7L7F7|L7|FJ F7 F7F7|L--JL7FJ||LJF-JLJ||F7F7 FJL-7              ',
     '          F7 ||||FJL7F7|L7F---J|F-JL7FJLJF--JF7F7L7|L7F7F--JFJLJL7FJL-JF--JF7|FJ|LJFJ|L7FJL-J|||L7F---JL7||F-JF7 FJLJLJL-JF--JF7            ',
     '         FJL-JLJ||F-J||L7LJF--7|L--7||F-7L--7|LJ|FJL-J||L7F7L7F--JL---7|F7FJ||L7|F7L7L7||F7F7LJ|FJL-7F7FJ||L-7||FJF-7F---7L---J|            ',
     '         |F7F7F7|||F7|| L7FJF-JL7F7|||| L---JL7FJL7F--JL-J|| |L7F7F--7|LJ|L7||FJLJL7|FJ|LJLJL-7||F7FJ||L7||F-J||L7L7|L--7|F----J            ',
     '         ||LJLJ|LJ||LJ|F7LJ L--7||||LJL--7F7 FJL7FJ|F7  F7||FJFJ|LJF-JL-7|FJ||L7F7 ||L7| F7F7FJ|LJ|L-JL7|LJL-7|L-JFJL---J|L---7             ',
     '         LJF7  L-7|L7FJ||F7 F7FJLJ|L-7F--J||FJF-JL7||L7FJ||||FJ L-7| F--J||FJ|FJ|L7|L7|L7|LJ|L7L7FJF---J|F---JL7F7L----7 L----J             ',
     '           || F--JL7|L7|||L-J|L--7L7FJL-7FJ|L7|F7FJ||FJ|FJ|||L-7 FJL7L--7LJL7|| L7||FJ|FJL-7|FJFJL7| F7 ||F7F7FJ||F7F7FJF7F7F7  F7          ',
     '          FJL7L---7|L7|||L--7|F--JFJL-7FJL7L-J|||L7LJL7||FJ||F-JFJF-JF-7L--7||L7FJ||L7|L7F-JLJFJ FJ|FJL7|||||LJFJLJLJLJFJLJLJL-7||          ',
     '          L-7|F---JL-J|||F7FJ|L--7|F7 ||F7L-7FJ|| L-7FJ||L7|||F7|FJF7L7| F7|||FJL7||FJL7|L7F--JF7L7|L7FJ|LJ||F-J F7 F7 L7F----7LJL7         ',
     '          F-J|L------7LJ|||L7L-7 |LJ|FJ|||F7||FJ|F7FJL7|L7|||LJ||L7||FJL7||||||F7|||L7FJL7|L7F7||FJL7||FJF-J|| F-JL-JL7FJL---7L---J         ',
     '          L-7L-------JF7LJL-JF7|FJF7||FJ|||||LJFJ|||F7||FJ|||F7|L7LJ|L7FJ|||||||||||FJL7O||FJ|||LJF7LJLJOL--JL-JF--7F-J|F----J F-7          ',
     '        F-7 L7F-7F7F--JL--7F7|||L-J||||FJLJLJF-JFJ|LJ|||L7||LJ||FJF-JFJL-J||LJ||LJLJ|F-JFJ|L7|LJOFJL-------7F7F-JF7LJF-J|F7F7F7|FJ          ',
     '        L7|  LJ LJLJ F-7F-J|LJ|L---JLJ|L-7F--JF7|FJF-JLJO||L7FJ|L7L-7|F---J|F-JL---7|L7OL7L7|L7F7L-7F-7F--7||||F-JL-7|F-J||||||||           ',
     '         |L7F-7F7F7 FJFJL--J FJF7F---7L-7||F7FJ||L7L----7||O|L7L7|F-J|L7F-7|L7F7F7FJ|FJF7|FJ|FJ|L--JL7LJOFJLJLJL7F--J||F7|||||LJL-7         ',
     '         |FJL7LJLJL7L7L-----7L-JLJ F7L7O||LJ|L7|L7L7F--7|LJFJFJFJ|L7FJFJ|O||OLJ|||L7|L-J||L7LJOL--7F-JF--J F7 F7||F7 |LJLJLJLJF---J         ',
     '     F7F-J|F7|F---7L-JF----7L7 F-7FJL-JFJL-7L7|L-JFJL-7||F7L7|OL7|FJ|FJFJFJL--7||L7|L7F7|L7L-7OF7FJ|F7L----JL7|||||L-JF7F---7FJF-7          ',
     '     |LJF7|||LJF7 L---JF7F7L7L7|FJL--7OL7F-JFJL7F-JF7FJ|LJ|FJL7FJ|L7|L7|FJF-7FJ|L7LJO||LJO|F7L7||L7||L------7LJLJLJF7FJ|L-7 |L-JFJ          ',
     '     L--J|LJ|F7||F---7FJLJ| L7LJ|F7F-JF7LJF-JF7||F7||L7|F-J|F7|L7|O||FJ|L7L7|L7L7|F--J|OF7LJL-J||FJ||F-7F7F7L-7F-7FJLJFJF7|FJF7FJ           ',
     '     F-7FJF7LJLJ|L-7FJL--7L-7L-7LJLJF-JL7OL-7|LJ||||L7||L-7LJ|L7|L7LJL7|FJFJL7L7LJL7F7L-JL----7||L-JLJOLJLJL-7|L7|L--7L-JLJ|FJ|L7           ',
     '   F7L7|L-JL---7|F7|| F--JF7L-7L----JF-7L7F7LJOFJ||L7||L7FJF-JFJL7|F--J||FJF7|FJOF7||L7F---7F7||L--7F7F------JL7||F--JF7F7 || L-J           ',
     'F--J|FJ|F------JLJLJL-JF7FJ|F7L------JOL7LJL--7L7||FJ|L7||OL-7L-7LJL--7||L-J|||F-JLJL7||F--J|LJL--7|||L------7 LJLJF--JLJL7|L-7F7           ',
     'L--7|L7LJF------7F7F-7FJ|| LJL---------7|F---7|FJ|LJO|FJLJF--JF7L-7F--J|L7F-JLJ|F7F7FJLJL7F7L-7F--JLJL------7L--7F-JF7F---JL-7LJL-7         ',
     'F--JL-JF-JF7F--7LJLJ LJ LJF----7F------JLJF7FJ|L7L-7FJL--7L7F7||F7|L-7FJFJL-7F7|||||L---7LJ|F-JL-----7F----7L---J|F-JLJF----7|F7F-J         ',
     'L7F7F--JF-J||F7L7 F7 F7 F7L---7LJF----7OF7||L-JOL7FJL7F7FJO||||||LJF-JL7L7F7LJ|||LJ|F7F7|F-J|F-------J|F---JF--7 || F7 L7F7FJ||LJ           ',
     ' LJ|L7F-JF7LJ|L7L-JL-JL-JL-7 FJF-JF--7L-JLJ|OF7OO|L-7||LJF7|||||L-7L-7FJO|||F-JLJOFJ|||LJL7FJL7F7F7F-7|L-7F7L7FJFJL-JL--J|LJ LJ             ',
     '   L-JL7FJL-7|FJF7F-7F-7F-7L-JFJF7L7OL7F7F7L-JL7FJF7||L7FJLJ|LJL--JOFJ|F-J||L-7OF7L7||L-7FJL7FJ|||||OLJF7LJL-JL-JF7F7F--7L7F7F----7         ',
     '       ||F--J|L-J|L7||FJ| L-7FJFJL-JF7LJLJL-7F-JL-J|||FJL7F7L---7F--JFJL-7||F7|FJL-J|L7FJL7FJL-JLJLJF--JL------7FJLJ|L7 L7LJ||F---J         ',
     '       ||L--7| F7L7|LJL7|F--J| L----JL-7F7F7LJF-7F7||LJF-J||F7F7|L7F-JF--J|LJ||L7F-7|O||F-JL7OF7F7F7L---------7LJ F7L7L-7|F7LJL-7           ',
     '       LJ   LJFJ| LJF--J|L-7FJF---7F7F7LJLJL-7L7LJ||L-7L7FJ||LJLJOLJF7L7F7L-7||FJ|FJL7|||F7FJFJ||LJ|F7F---7F--J F-J| L7FJ|||F7F-J           ',
     '            F7L7|F7 L--7|F-J| L7F7LJLJL7F---7L-JF-JL-7|FJL7|L7OOOF--JL-J||F-JLJL-JL--JLJLJLJOL7|L-7|||L--7|L----JF7|F7LJ LJLJLJ             ',
     '           FJL-JLJ|F7F7LJL--JF7LJ|F---7||F7OL7F7L7F7OLJ|F-JL7L7F7L-7F7F-J|L---7F------7F7F-7F-JL--JLJL---J|F-----J|LJ|F--7F7F-7             ',
     '         F-JF7F--7LJLJL------JL-7LJF-7|LJ|L-7|||FJ||F7O|L7OFJFJ|L--J||L7OL7F-7||F7F7F7LJLJFJL7F7F-7F---7F7LJF7 F-7|F7LJF7LJLJFJ             ',
     '         L--JLJF7L------------7FJ FJOLJOFJF7||||L-J||L7|FJFJFJOL7F7FJ|FJF-JL7||||LJLJL---7L-7LJLJOLJF7OLJ|F-JL7|FJLJ|F-JL-7F7L7             ',
     '         F-----JL7F7 F-7 F7F7FJL-7L--7F7L7|LJLJL7F-J|FJLJOL7L--7LJ|L7||FJF7FJLJLJOF7F7OF-JF7L7F-7F7FJL--7LJF-7LJL-7 LJF7F7LJL7|             ',
     '         L7F----7LJL7L7|FJLJ|L7F7|F--J|L-JL----7LJOFJ|F7F7OL7F7|OOL-J||L7||L-7F---JLJL-JF7|L7|L7|||L---7L--JFJF7F-JF7FJLJL7F7LJ             ',
     '          LJ F7 L--7|FJLJF-7| ||LJL---JF-------JOF7|FJ|LJL7OLJLJOOOOOLJOLJL7FJ|F--------JLJFJL-JLJL--7OL---7L-J|L--JLJF--7LJL---7           ',
     '          F7FJL----JLJF-7|FJ|FJL------7L--7F7F7OFJLJL-JF7FJOOOOOOOOOOOOOOOO|L7||F---------7L--------7|F----JF-7|F7F---JF7L------J           ',
     '         FJLJF-------7L7LJL7LJF7F----7|F7FJ|||L-JF-7F--JLJOOOOOOOOOOOOOOOOOL-JLJL7F-7F-7F7L---------JLJF---7|FJLJLJF---JL7 F--7             ',
     '         L---JF------JFJ F7L7FJLJF7F-JLJ|L7|||F--JFJL---7OOOOOOOOOOOOOOOOOOOOOOF7LJFJL7||L7F-7F7F7F7F7FJF--J|L-7 F7|F-7F7L-JF7L-7           ',
     '          F--7L---7F7FJ FJL7LJF--JLJF7F7L-J|LJL--7L7F7F7|F-7OOOOOOOOOOOOOOOOOOFJ|F7L--J||OLJOLJLJLJLJLJOL--7|F7L7|LJL7LJL---JL-7|           ',
     '          L-7L-7F-J|||F-JF7L--JF7F--JLJL7F7|F-7F7L7LJLJ|LJFJOOOOOOOOOOOOOOOOOOL7|||OF7OLJF-7F-7F7F-7F7F-7F7LJ|L-J|F--JF----7 F7LJ           ',
     '          F7L-7|L--JLJL--JL--7FJ||F-----J||||O|||FJOF7O|F-JOOOOOOOOOOOOOOOOOOOFJLJL-JL7F7L7|L7LJ|L7|||L7LJL7FJF7 |L---JF--7L-JL7            ',
     '       F7FJL--J|F7F7F7F7F----J|FJ|L------JLJL7LJ|L--JL7LJF7F7OOOOOOOOOOOOOOOF-JF7F7F-7LJL-JL7L-7|FJLJL7L--7||FJL7|F----JF7L---7|            ',
     '       |LJF---7LJLJLJLJLJF----JL-J F7F7F7F7F7L-7L7F7F7|OO||||OF7OOOOOOOOOOOOL--JLJ||FJF7F-7FJF7|LJF--7L7F-JLJ|F-J||F----JL7F-7LJ            ',
     '       L-7|F7 L-7F-------JF7F7 F7F-JLJLJLJ|||F7L7LJLJLJOFJ||L-JL7OOOOOOOOOOOOF-7OOLJL7|LJFJ|FJLJF-JF-JFJL----JL--JLJF-----J|FJ              ',
     '         LJ|L---J| F---7F-JLJL-JLJF-----7OLJLJL-JF7F-7F7L7||F-7FJOOOOOOOOOF-7L7|OF7F7LJF7L7LJF-7|F-JF7L7OF7F-7F7F-7FJF7F--7|L7              ',
     '           L7F---JFJF-7|L--7F--7F-JF7F--JF7F----7|||FJ||FJLJ|OLJOOOOOOOOOOL7|FJL-JLJ|F7||FJF7L7LJL7FJL7L-JLJ LJLJ |L-J||F-J|FJ              ',
     '            LJ F--JFJFJL7F7LJF7||F-JLJF7FJLJF7F7LJ||L-JLJF7FJF7OOOOOOOOOOOO||L-----7|||||L7||FJOF7LJF7L--------7F7|F7FJ|L--JL-7             ',
     '           F---JF--J |F7LJ|F7||LJL----JLJF--JLJ|F7LJF-7F7|||O|L-7OOOOOOOOOO|L------JLJLJL7LJ||F-JL--JL---------J||LJ|L-JF7F7F7|F7F7         ',
     '         F-JF---JF---J||F7LJLJL7F7F------JF7F-7LJL--JOLJLJLJFJF-JOOOOOOOOOFJF7F---------7L--J|L----7F7F7F-------JL-7L7F7|LJLJLJ||||         ',
     '         L7FJ F-7L----JLJ|F7F-7LJ|L-7F7F--JLJFJOF-----7F7F--JFJOOOOOOOOOOOL-J||F-------7|F7F7|F----J|LJLJF7F------7L7LJLJF7F7F7|LJL---7     ',
     '          ||F-JFJF-------J|LJ |F7L--J|LJF----JOFJF----J|LJF7FJOOOOOOOOOOOOOOOLJL------7LJ|||||L--7F7L7F--JLJF7F--7L7L--7FJLJLJ|L-7F---J     ',
     '          LJL-7L7L----7F-7|F--J|L----JF7L-----7L7|F-7F7|F-JLJOOOOOOOOOOOOOOOOOOF------JF7|LJLJF-7LJ|FJL---7 |LJF-J L7F-J|F7F7FJF-JL-7       ',
     '            F7L7L----7|L7LJL7F7L7F----JL----7FJO|LJFJ|||L7F7F7OOOOOOOOOOOOOOOOOL---7F7FJ|L7F7OL7|F7LJF7F--JFJF7|F7F7|L7FJ|LJLJFJF---J       ',
     '            || L-7F-7LJFJ F7||L-JL--------7OLJOFJF7|FJLJFJ|LJL7OOOOOOOOOOOOOOOOOF--J|LJOL-J||F7||||F7||L---JFJLJ|LJ||FJL7L7F-7L7L-----7     ',
     '            |L---J| L-7|F7|LJL7F----------JF7F7L7|LJ|F-7L-JF7FJF7OOOOOOOOOOOOOOFJF7FJF7F--7|||||LJLJLJL7F---JF7 |F-JLJF-JFJL7L-JF-----J     ',
     '          F7L-----JF7 LJ|LJF7FJL-7F-------7|LJ|FJL--JL7L7F7|LJFJL7OOOOOOOOF---7L-J||FJLJF7LJLJ||F-7F--7|L----JL7|L--7 L-7L--JF--JF7         ',
     '          |L-------JL---JF7|||F7FJ|F------JL-7LJF7F-7FJFJ|||F7L7FJF7F7F7F7L--7|OOOLJL-7FJL---7LJL7LJF7|L--7F7F7||F--JF7FJF---JF-7|L7        ',
     '          L----------7F-7|||LJ||L-J|F----7OF7|F-J|L7|L7L7|LJ|L7||FJ|||||||OF-JL7OF---7|L7OF7FJF--JF-JLJF-7LJLJLJ||F7 ||L7| F7 L7||FJ        ',
     '         F--7F------7LJ ||||F-JL---J|F---JFJLJL-7L-JL7L7LJF-JFJ|||FJ||||||OL--7L7L--7|L-JFJLJFJOF-JF7F7|FJF7 F7FJLJL-JL-JL7||F-JLJL-7F-7    ',
     '         L-7|L-----7L---J|||L-------JL----JF---7L--7O|FJF7L-7L-J||L-J||LJ|F---JFJF-7|L7OFJF7FJF7L7FJ||LJL-J|FJLJF7F7F----7LJ||F-----J|FJ    ',
     '         F-JL7 F7F-JF7F7FJ||F---7F---7F-7F7L-7FJF--JFJ|O||F7L-7FJL7F-J|F-JL-7F7|FJFJ|FJFJFJ||FJ|OLJOLJF---7LJF-7|LJLJF-7FJF7LJL----7FJL7    ',
     '         L7F7|FJLJF7|LJ|| ||L--7|L--7|L7|||F-JL-JF7OL-JFJ||L--J|F7||F7|L7F7OLJ|||FJFJL7L7L7LJL7L--7OF7L--7L-7L7|L7F7 |FJL7||F-7F--7LJF-J    ',
     '         FJ||LJF--JLJF-JL7LJF--JL---JL7|LJLJOF7OFJL-7F7L7|L-7F7LJ||LJLJFJ|L7OFJLJL7L-7L7L-JF-7L7F7L-JL---JF7|FJL7LJL-JL-7||||FJL-7L--J      ',
     '         L-JL-7L7F---JF-7L7FJF7F-----7LJF7F7FJL-JF--J||FJL7OLJ|F-JL-7F-JOL7L7L7F--JF7L7L7OFJFJFJ|L7F7F7F-7||LJ  L----7F7|LJLJL-7FJF-7       ',
     '             FJFJL---7| L-JL-J||F----JF7|LJLJF--7L--7|||F-JF7FJL7F7FJ|F7F7L7L7|L--7|L-JFJFJFJOL-JOLJLJLJOLJL-7 F7F7F7LJLJ F7F-7|L-JFJ       ',
     '         F7F7L7L-7F-7LJF7F7F--J|L-----JLJF7F7|F7L---J||||F7||L7FJ||L7|||||FJFJ|F--JL7F-JOL7|F7F7F7F7F-------7L7|||LJL-7F--JLJFJ|F-7L7       ',
     '       F7|||| L--JL7|F7||||L---J F-------JLJLJ|L7F7F7||||||||FJ|FJL-JLJ||||FJFJL7F7FJL7F-7|||||||||||F7F---7L7LJLJF7F-JL7F---JFJ|FJFJ       ',
     '       |LJLJL-7F-7FJLJ|||||F7F7F7L----7OF7F-7FJFJ|||||||||LJLJFJL-----7||LJL7L7FJ||L7FJL7|||||||||||LJLJF--JFJF7F7||L-7FJL---7L7|L-J        ',
     '       L-----7||FJL7F7LJLJLJLJ|||F7F-7L-JLJFJL7|FJ||||LJ|L-7F-JF-7F--7||L-7FJO|L7|L7||OFJLJ||||LJ||L7OF7L--7L-JLJLJL-7LJF----J |L7F7        ',
     '          F7FJLJ|F7LJ|F------7LJLJ|L7|F7F7FJF-JLJFJ|||F-JF7||OFJFJL-7||L-7||F7L7||FJ|L7L-7FJ|||F7LJFJFJL---J F------7|F7L----7 L7||| F7     ',
     '       F7FJ|L-7FJ||F7LJF7F7F-JF7F7L-J||LJLJFJF---JFJ|||F7|LJL7L7|F--JLJF-J|LJ|O|LJL7L7L--J|O||LJL7FJOL-------JF7F--7|||L-----JF7LJ|L-JL7    ',
     '      FJ|L7|F-J| |||| FJLJ|L--JLJL--7LJF7F7L7|F-7O|FJ||||L--7L-J|L----7L-7L7FJFJF--JOL--7FJFJL--7|L-7F-----7F7|||F7LJLJ F----7|L--JF---J    ',
     '      L7L-J|L-7L-JLJL7L--7L7F7F7 F--JOFJ||L7|||FJFJ|FJ|||OF-JF--JOF--7L-7L7|L7L7|F7F7F7O|L7L7F--JL7FJL----7||LJLJ|| F7F7|F---J|F---J        ',
     '       L--7|F7L-7F7F7L-7 L7LJLJL7L-7F-JFJ|FJ||||O|FJL7LJL7L-7L---7L-7|F7L7||FJFJLJ|||||FJFJFJL7OF7||F7OF7FJLJ F-7|L7|||LJL7F--JL----7       ',
     '     F7F--J|||F-J|LJL-7|F-JF-7F7L--JL-7|FJL7||||FJL7FJF--JF7|F---JF-JLJL7||||OL7F7LJLJ|L7L7L-7L7||||||FJLJF7F7|FJ|FJ|||F--J|F--7F---J       ',
     '   F-JLJF-7|||L-7|F7F-J|L-7L7LJL7F-7OFJ||F-J|LJ|L-7|L7|F7O||||OF7OL----7||LJL7FJ|L7F--JOL7|F7|FJ|||LJ|L---JLJLJL7||FJLJL---JL-7|L---7       ',
     '   L-7F7|FJLJL7 LJ|LJF7L--JFJF--J| L7L7LJL7FJF-JOFJL7|||L7|||L7|L-7F--7|||F--JL-JFJL7F7F7||||||FJ|L-7L7F7F--7F-7LJLJF7F-7F----J|F---J       ',
     '     LJLJL-7F-JF--JF7|L----J |F7FJF-JOL-7FJL7|OF7L7FJ||L7||||FJL7FJL7FJ||||F7F7F7L7FJ||||||||||L7|F7|FJ||L-7|L7|F7F-JLJFJL----7|L--7        ',
     '  F7F7F7 F-JL--JF7FJ||F-----7LJLJFJF7F7FJL7FJL7||FJ|FJL7|||||L7FJL7FJ|FJ||||||||L7|L7|||LJ|||||FJ|||||FJ|F7|L7|LJ|L---7L7F7F--JL---J        ',
     '  |LJLJL-JF7F-7FJ|| ||L----7| F--JFJ||LJF-JL-7||LJ LJ FJ|||||FJ|F7||FJL7LJ||LJ||FJL7|||| FJ|LJ||FJ|||LJ LJ|L7LJF7L7F--JFJ||L------7         ',
     '  L--7F7F7|LJFJL7||FJ|F--7FJL-JF7FJ |L-7L7F7FJ|L--7 F7L7|LJ||L7LJ|LJL-7L7FJL-7||L7FJ||||FJFJF-J|L7||L---7 L-JF-J|FJL--7L7||F7F7F7FJ         ',
     '  F7FJ|LJ|L7 L--JLJL7||F7LJF-7FJ|L-7|F7|FJ||L7|F--JFJL-JL-7LJ |F7L-7F7|FJL7F7||L7||FJ||||FJFJF7|FJ|L-7F-JF---JF-JL7F-7L7||LJLJLJLJ          ',
     'F-JLJFJ FJFJF----7 FJ|LJL--J || L-7|||||L7||FJ|L-7 L7F7F7FJ F-J||F7||LJL-7||LJL7|||L7||||L7|FJ|||FJF-JL--JF---JF7FJL7|FJ|L----7             ',
     'L7F--J  |FJFJF7F7L-JFJ F-----JL--7LJ||LJ |||| |F-JF-J||||L7FJF7|LJLJL7F--J|L--7|||L7LJLJ|FJ||FJ||L7L7F-7F7L----J|L7FJLJFJF7F--J             ',
     ' ||  F7FJL7L7||||F7FJF7L-7F7F7F7FJ FJ| F-J||L7LJF-JF7||||FJ|FJ|L--7F-JL-7FJF7FJ||L7|F---JL7||L7||FJ || LJL7F7F7FJ |L-7 L-JLJ                ',
     ' LJF-JLJF7|FJ|LJLJLJFJL-7LJ|||||L-7L7|FJF7|L7L-7|F7||||||L7|L7L7F-J|F7F7||FJLJFJL7|||F--7FJLJFJ|LJ FJL7F7FJ|LJLJF7|F7L----7                 ',
     '   L---7|LJL-J F7F--JF-7L--J||||F-J LJ|FJ|| |F-J||||LJ|||FJ|FJFJL-7LJ|||||L--7L--J||||F-JL-7 L7L-7FJF7LJ|L7L-7F7||LJL7F-7FJ                 ',
     '    F--JL7 F---JLJF-7L7L7F7FJ||LJ F---J| LJFJL-7LJ|L7FJ|||FJ| |F-7L-7||||L7F-JF-7 LJ||L----JF7|F7|L-J|F-J |F7LJLJL--7LJ |L---7              ',
     '    |F7F7L7|F-7F7FJFJFJFJ|||FJL--7L-7F7L-7FJF--JF7|FJL7|||L7L7|L7|F7|||LJFJL--JFJF7 LJF-----JLJ||L-7FJL--7LJ|F--7F--JF7FJF7F-J              ',
     '    LJLJ|FJ||FJ|||FJFJ L7|||L7F-7L7FJ||F7|L7L-7FJLJ|F7|||| L7||FJ||LJLJF-JF7F7FJ |L--7L--7F7F7FJ|F-JL7F--JF7|L-7|L---J|L7|LJ                ',
     '     F--J| LJL7|LJL-J   LJ|| LJFJFJL7||||L7|F7|L7F7||LJ|LJF-J||L7|L---7|F7|LJ|L--JF7FJ F7LJ|||L7|L7F7|L---J||F-J|F7F7FJ LJ                  ',
     '     |F--J   FJ|F-7 F7 F--JL--7L-JF-J|||L-J||LJ ||LJL-7|F7L7FJ|FJ|F--7|||LJ FJF7F-J||F-JL--J||FJ|FJ|LJF7F-7||L-7||LJ|L-7                    ',
     '     LJ      |FJL7L-JL7L-7F7F7L7F-JF7||L-7 LJ F-JL7F--J||L-JL7|L7|L-7LJLJF--JFJ|L-7||L-7F-7FJ|L7LJ L-7|LJ LJ|F7||L-7|F7|                    ',
     '             ||  L7F-7L--J|LJ|FJL7FJ|||F7L-7F7L--7|L7F7|L7F--JL7|L7FJF--7L7F7| |F-J||F-JL7||FJFJF----JL---7FJ|LJL7FJLJLJ                    ',
     '             LJ  FJ|FJF7F7L-7|L7 || LJLJL7FJ|| F-JL7LJ||FJL---7LJ ||FJF7|FJ||L7|L7FJ|L7F7|LJL7L7|F---7F-7FJL7L--7|L-7                       ',
     '                 |FJL7|LJL7FJL-JFJL---7F7|L7|L-JF-7|F-J|L-7F7FJF--JLJFJLJL7|L7||FJL7|FJ|LJ F-JFJLJ F-JL7LJF7L7F-J|F7L-7                     ',
     '                 LJ  || F7|L-7F-JF7F--J||L-J|F-7L7||L-7L7FJ||L7L7F7F7L7 F7|L7|||L-7LJL7L--7L--JF7F7L7F7L--J|FJL7FJ||F-J                     ',
     '                    FJ|FJLJF7||F7||L---JL-7FJ| |FJLJF7|FJL-J|FJ LJ||L7L7||L7|||L7FJ F-JF--J F7FJLJL-J||F--7|L7FJL7|||                       ',
     '                    L7||F-7|LJ|||||F-7F7F-J|FJFJL-7FJLJL---7|L7F--JL7L7LJ|FJ|LJ ||F-JF-JF---JLJF--7F7||L-7LJFJL-7||||                       ',
     '                     LJ||FJL-7LJ|||L7||LJF-JL7L7F7|L--7F--7|L7||F7F7|FJF-JL7L7  LJL7FJ  L-7F7F7|F-J||||F-JF7L---J||LJ                       ',
     '                       ||L-7FJF-J||FJ|L-7L-7FJ ||||F--JL-7LJFJ|||||||L7L--7L7L7  F-JL7  F7LJLJLJL7FJ|||L--JL---7 LJ                         ',
     '                       LJF-J|FJF7|LJ |F-J  ||  |||||F7F7FJF7L7|LJ||||FJF--J L7L7 L-7FJF-JL-7 F---J|FJ||F--7F7F7|                            ',
     '                         L--JL-J|L7  ||   FJL7 LJLJ|||||L-JL7LJF-J|LJL7L-7   L7L7  LJ L-7F7L7L---7|L-J||F7LJLJLJ                            ',
     '                               FJFJ  LJ   L7FJ     LJLJ|F7F-J  |F-JF--JF-J    L-J       ||L7L----J|F--JLJL------7                           ',
     '                             F-JFJ         LJ        F-J|||    |L7 |F-7L7               LJ L-7F--7|L---7F-------J                           ',
     '                             L--J                    |F7|LJ    L-J LJ L7|                    ||F-J|F---JL--7F7 F7                           ',
     '                                                     ||LJ             FJ|                    |||F-JL-7F7F7FJ|L-J|                           ',
     '                                                   F-JL7              L-J                    LJ||F---J||||L-JF7FJ                           ',
     '                                                   L---J                                       LJL7F7FJ|||F--J|L7                           ',
     '                                                                                                  ||LJFJ||L--7L7L7                          ',
     '                                                                                                  LJF-JFJ|F7FJ L-J                          ',
     '                                                                                                    L7FJ |||L--7                            ',
     '                                                                                                     LJ  LJL---J                            ']


